﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Diagram

Namespace Forum_Sample
	Partial Public Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			Dim rect As New Syncfusion.Windows.Forms.Diagram.Rectangle(200, 100, 100, 70)
			Dim lbl As New Syncfusion.Windows.Forms.Diagram.Label(rect,"A")
			rect.Name = "Node-A"
			rect.Labels.Add(lbl)
			rect.PropertyBag.Add("Role","Manager")
			diagram1.Model.AppendChild(rect)

			 Dim rect1 As New Syncfusion.Windows.Forms.Diagram.Rectangle(100, 250, 100, 70)
			Dim lbl1 As New Syncfusion.Windows.Forms.Diagram.Label(rect1,"B")
			rect1.Name="Node-B"
			rect1.Labels.Add(lbl1)
			rect1.PropertyBag.Add("Role","Developer")
			diagram1.Model.AppendChild(rect1)

			Dim rect2 As New Syncfusion.Windows.Forms.Diagram.Rectangle(300, 250, 100, 70)
			Dim lbl2 As New Syncfusion.Windows.Forms.Diagram.Label(rect2,"C")
			rect2.Name= "Node-C"
			rect2.Labels.Add(lbl2)
			rect2.PropertyBag.Add("Role","Developer")
			diagram1.Model.AppendChild(rect2)

			Dim line1 As New LineConnector(New PointF(100, 100), New PointF(200, 200))
			line1.HeadDecorator.DecoratorShape = DecoratorShape.Filled45Arrow
			rect.CentralPort.TryConnect(line1.TailEndPoint)
			rect1.CentralPort.TryConnect(line1.HeadEndPoint)
			diagram1.Model.AppendChild(line1)

			Dim line2 As New LineConnector(New PointF(100, 100), New PointF(200, 200))
			line2.HeadDecorator.DecoratorShape = DecoratorShape.Filled45Arrow
			rect.CentralPort.TryConnect(line2.TailEndPoint)
			rect2.CentralPort.TryConnect(line2.HeadEndPoint)
			diagram1.Model.AppendChild(line2)

			diagram1.Controller.SelectionList.Clear()

			AddHandler diagram1.EventSink.NodeClick, AddressOf EventSink_NodeClick
		End Sub

		Private Sub EventSink_NodeClick(ByVal evtArgs As NodeMouseEventArgs)
			If TypeOf evtArgs.Node Is Node Then
				Dim nd As Node = evtArgs.Node
				If nd.Edges.Count >0 Then
					If nd.EdgesEntering.Count > 0 Then
						For Each line As ConnectorBase In nd.EdgesEntering
							Dim nd1 As Node = TryCast(line.FromNode, Node)
							If nd1.PropertyBag.Count > 0 AndAlso nd1.PropertyBag("Role").ToString() = "Manager" Then
								MessageBox.Show(nd1.Name & " is the Manager of " & nd.Name)
							End If
						Next line
					End If
					If nd.EdgesLeaving.Count > 0 Then
						For Each line As ConnectorBase In nd.EdgesLeaving
							Dim nd1 As Node = TryCast(line.ToNode, Node)
							If nd1.PropertyBag.Count > 0 AndAlso nd1.PropertyBag("Role").ToString() = "Developer" Then
								MessageBox.Show(nd1.Name & " is reporting to " & nd.Name)
							End If
						Next line
					End If
				End If
			End If
		End Sub
	End Class
End Namespace
